diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-phy.cc ns-3.38/src/lr-wpan/model/lr-wpan-phy.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-phy.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-phy.cc	2023-03-16 20:54:23.632868500 -0700
@@ -20,6 +20,7 @@
  */
 #include "lr-wpan-phy.h"
 
+#include "lr-wpan-constants.h"
 #include "lr-wpan-error-model.h"
 #include "lr-wpan-lqi-tag.h"
 #include "lr-wpan-net-device.h"
@@ -49,13 +50,13 @@
 
 NS_OBJECT_ENSURE_REGISTERED(LrWpanPhy);
 
-// Table 22 in section 6.4.1 of ieee802.15.4
-const uint32_t LrWpanPhy::aMaxPhyPacketSize = 127; // max PSDU in octets
-const uint32_t LrWpanPhy::aTurnaroundTime = 12;    // RX-to-TX or TX-to-RX in symbol periods
-
-// IEEE802.15.4-2006 Table 1 in section 6.1.1. and IEEE 802.15.4c-2009, IEEE 802.15.4d-2009
-// The index follows LrWpanPhyOption (kb/s and ksymbol/s)
-const LrWpanPhyDataAndSymbolRates LrWpanPhy::dataSymbolRates[IEEE_802_15_4_INVALID_PHY_OPTION] = {
+/**
+ * The data and symbol rates for the different PHY options.
+ * See Table 1 in section 6.1.1 IEEE 802.15.4-2006, IEEE 802.15.4c-2009, IEEE 802.15.4d-2009.
+ * Bit rate is in kbit/s.  Symbol rate is in ksymbol/s.
+ * The index follows LrWpanPhyOption (kb/s and ksymbol/s)
+ */
+static const LrWpanPhyDataAndSymbolRates dataSymbolRates[IEEE_802_15_4_INVALID_PHY_OPTION]{
     {20.0, 20.0},
     {40.0, 40.0},
     {20.0, 20.0},
@@ -64,20 +65,27 @@
     {250.0, 62.5},
     {100.0, 25.0},
     {250.0, 62.5},
-    {250.0, 62.5}};
-// IEEE802.15.4-2006,IEEE 802.15.4c-2009, IEEE 802.15.4d-2009  Table 19 and Table 20 in section 6.3.
-// The PHR is 1 octet and it follows phySymbolsPerOctet in Table 23
-// The index follows LrWpanPhyOption
-const LrWpanPhyPpduHeaderSymbolNumber
-    LrWpanPhy::ppduHeaderSymbolNumbers[IEEE_802_15_4_INVALID_PHY_OPTION] = {{32.0, 8.0, 8.0},
-                                                                            {32.0, 8.0, 8.0},
-                                                                            {32.0, 8.0, 8.0},
-                                                                            {2.0, 1.0, 0.4},
-                                                                            {6.0, 1.0, 1.6},
-                                                                            {8.0, 2.0, 2.0},
-                                                                            {8.0, 2.0, 2.0},
-                                                                            {8.0, 2.0, 2.0},
-                                                                            {8.0, 2.0, 2.0}};
+    {250.0, 62.5},
+};
+
+/**
+ * The preamble, SFD, and PHR lengths in symbols for the different PHY options.
+ * See Table 19 and Table 20 in section 6.3 IEEE 802.15.4-2006, IEEE 802.15.4c-2009, IEEE
+ * 802.15.4d-2009.
+ * The PHR is 1 octet and it follows phySymbolsPerOctet in Table 23.
+ * The index follows LrWpanPhyOption.
+ */
+const LrWpanPhyPpduHeaderSymbolNumber ppduHeaderSymbolNumbers[IEEE_802_15_4_INVALID_PHY_OPTION]{
+    {32.0, 8.0, 8.0},
+    {32.0, 8.0, 8.0},
+    {32.0, 8.0, 8.0},
+    {2.0, 1.0, 0.4},
+    {6.0, 1.0, 1.6},
+    {8.0, 2.0, 2.0},
+    {8.0, 2.0, 2.0},
+    {8.0, 2.0, 2.0},
+    {8.0, 2.0, 2.0},
+};
 
 TypeId
 LrWpanPhy::GetTypeId()
@@ -593,7 +601,7 @@
 {
     NS_LOG_FUNCTION(this << psduLength << p);
 
-    if (psduLength > aMaxPhyPacketSize)
+    if (psduLength > lrwpan::aMaxPhyPacketSize)
     {
         if (!m_pdDataConfirmCallback.IsNull())
         {
@@ -861,7 +869,7 @@
             m_trxStatePending = IEEE_802_15_4_PHY_TX_ON;
 
             // Delay for turnaround time (BUSY_RX|RX_ON ---> TX_ON)
-            Time setTime = Seconds((double)aTurnaroundTime / GetDataOrSymbolRate(false));
+            Time setTime = Seconds((double)lrwpan::aTurnaroundTime / GetDataOrSymbolRate(false));
             m_setTRXState = Simulator::Schedule(setTime, &LrWpanPhy::EndSetTRXState, this);
             return;
         }
@@ -928,7 +936,7 @@
             //       even when the transmitter is not busy? (6.9.1)
             m_trxStatePending = IEEE_802_15_4_PHY_RX_ON;
 
-            Time setTime = Seconds((double)aTurnaroundTime / GetDataOrSymbolRate(false));
+            Time setTime = Seconds((double)lrwpan::aTurnaroundTime / GetDataOrSymbolRate(false));
             m_setTRXState = Simulator::Schedule(setTime, &LrWpanPhy::EndSetTRXState, this);
             return;
         }
@@ -1158,14 +1166,10 @@
 
             m_phyPIBAttributes.phyCurrentPage = attribute->phyCurrentPage;
 
-            LrWpanSpectrumValueHelper psdHelper;
-            m_txPsd = psdHelper.CreateTxPowerSpectralDensity(
-                GetNominalTxPowerFromPib(m_phyPIBAttributes.phyTransmitPower),
-                m_phyPIBAttributes.phyCurrentChannel);
-            // if the page is changed we need to also update the Noise Power Spectral Density
-            m_noise =
-                psdHelper.CreateNoisePowerSpectralDensity(m_phyPIBAttributes.phyCurrentChannel);
-            m_signal = Create<LrWpanInterferenceHelper>(m_noise->GetSpectrumModel());
+            // TODO: Set the maximum possible sensitivity by default.
+            //       This maximum sensitivity depends on the modulation used.
+            //       Currently Only O-QPSK 250kbps is supported so we use its max sensitivity.
+            SetRxSensitivity(-106.58);
         }
         break;
     }
@@ -1208,14 +1212,8 @@
 
             m_phyPIBAttributes.phyCurrentChannel = attribute->phyCurrentChannel;
 
-            LrWpanSpectrumValueHelper psdHelper;
-            m_txPsd = psdHelper.CreateTxPowerSpectralDensity(
-                GetNominalTxPowerFromPib(m_phyPIBAttributes.phyTransmitPower),
-                m_phyPIBAttributes.phyCurrentChannel);
-            // if the channel is changed we need to also update the Noise Power Spectral Density
-            m_noise =
-                psdHelper.CreateNoisePowerSpectralDensity(m_phyPIBAttributes.phyCurrentChannel);
-            m_signal = Create<LrWpanInterferenceHelper>(m_noise->GetSpectrumModel());
+            // use the prev configured sensitivity before changing the channel
+            SetRxSensitivity(WToDbm(m_rxSensitivity));
         }
         break;
     }
@@ -1687,15 +1685,11 @@
     m_edPower.lastUpdate = Seconds(0.0);
     m_edPower.measurementLength = Seconds(0.0);
 
-    // TODO: What is the RX sensibility that should be set for other frequencies?
-    // default -110 dBm in W for 2.4 GHz
-    m_rxSensitivity = pow(10.0, -106.58 / 10.0) / 1000.0;
-    LrWpanSpectrumValueHelper psdHelper;
-    m_txPsd = psdHelper.CreateTxPowerSpectralDensity(
-        GetNominalTxPowerFromPib(m_phyPIBAttributes.phyTransmitPower),
-        m_phyPIBAttributes.phyCurrentChannel);
-    m_noise = psdHelper.CreateNoisePowerSpectralDensity(m_phyPIBAttributes.phyCurrentChannel);
-    m_signal = Create<LrWpanInterferenceHelper>(m_noise->GetSpectrumModel());
+    // TODO: Change the limits  Rx sensitivity when other modulations are supported
+    // Currently, only O-QPSK 250kbps is supported and its maximum possible sensitivity is
+    // equal to -106.58 dBm and its minimum sensitivity is defined as -85 dBm
+    SetRxSensitivity(-106.58);
+
     m_rxLastUpdate = Seconds(0);
     Ptr<Packet> none_packet = nullptr;
     Ptr<LrWpanSpectrumSignalParameters> none_params = nullptr;
@@ -1704,6 +1698,61 @@
     m_errorModel = nullptr;
 }
 
+void
+LrWpanPhy::SetRxSensitivity(double dbmSensitivity)
+{
+    NS_LOG_FUNCTION(this << dbmSensitivity << "dBm");
+
+    // See IEEE 802.15.4-2011 Sections 10.3.4, 11.3.4, 13.3.4, 13.3.4, 14.3.4, 15.3.4
+    if (m_phyOption == IEEE_802_15_4_915MHZ_BPSK || m_phyOption == IEEE_802_15_4_950MHZ_BPSK)
+    {
+        if (dbmSensitivity > -92)
+        {
+            NS_ABORT_MSG("The minimum Rx sensitivity for this band should be at least -92 dBm");
+        }
+    }
+    else
+    {
+        if (dbmSensitivity > -85)
+        {
+            NS_ABORT_MSG("The minimum Rx sensitivity for this band should be at least -85 dBm");
+        }
+    }
+
+    // Calculate the noise factor required to reduce the Rx sensitivity.
+    // The maximum possible sensitivity in the current modulation is used as a reference
+    // to calculate the noise factor (F). The noise factor is a dimensionless ratio.
+    // Currently only one PHY modulation is supported:
+    // O-QPSK 250kpps which has a Max Rx sensitivity: -106.58 dBm (Noise factor = 1).
+    // After Rx sensitivity is set, this becomes the new point where PER < 1 % for a
+    // PSDU of 20 bytes as described by the standard.
+
+    // TODO: recalculate maxRxSensitivity (Noise factor = 1) when additional modulations are
+    // supported.
+    double maxRxSensitivityW = DbmToW(-106.58);
+
+    LrWpanSpectrumValueHelper psdHelper;
+    m_txPsd = psdHelper.CreateTxPowerSpectralDensity(
+        GetNominalTxPowerFromPib(m_phyPIBAttributes.phyTransmitPower),
+        m_phyPIBAttributes.phyCurrentChannel);
+    // Update thermal noise + noise factor added.
+    long double noiseFactor = DbmToW(dbmSensitivity) / maxRxSensitivityW;
+    psdHelper.SetNoiseFactor(noiseFactor);
+    m_noise = psdHelper.CreateNoisePowerSpectralDensity(m_phyPIBAttributes.phyCurrentChannel);
+
+    m_signal = Create<LrWpanInterferenceHelper>(m_noise->GetSpectrumModel());
+    // Change receiver sensitivity from dBm to Watts
+    m_rxSensitivity = DbmToW(dbmSensitivity);
+}
+
+double
+LrWpanPhy::GetRxSensitivity()
+{
+    NS_LOG_FUNCTION(this);
+    // Change receiver sensitivity from Watt to dBm
+    return WToDbm(m_rxSensitivity);
+}
+
 LrWpanPhyOption
 LrWpanPhy::GetMyPhyOption()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-phy.h ns-3.38/src/lr-wpan/model/lr-wpan-phy.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-phy.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-phy.h	2023-03-16 20:54:23.632868500 -0700
@@ -48,12 +48,12 @@
  *
  * Helper structure to manage the power measurement during ED.
  */
-typedef struct
+struct LrWpanEdPower
 {
     double averagePower;    //!< Average measured power
     Time lastUpdate;        //!< Last update time
     Time measurementLength; //!< Total measurement period
-} LrWpanEdPower;
+};
 
 /**
  * \ingroup lr-wpan
@@ -61,11 +61,11 @@
  * This data structure provides the Bit rate and Symbol rate for a given channel
  * See IEEE802.15.4-2006 Table 1 and 2 in section 6.1.1 and 6.1.2
  */
-typedef struct
+struct LrWpanPhyDataAndSymbolRates
 {
     double bitRate;    //!< bit rate
     double symbolRate; //!< symbol rate
-} LrWpanPhyDataAndSymbolRates;
+};
 
 /**
  * \ingroup lr-wpan
@@ -73,19 +73,19 @@
  * This data structure provides number of symbols for the PPDU headers: SHR and PHR
  * See IEEE802.15.4-2006 Figure 16, Table 19 and 20 in section 6.3
  */
-typedef struct
+struct LrWpanPhyPpduHeaderSymbolNumber
 {
     double shrPreamble; //!< Number of symbols for the SHR preamble
     double shrSfd;      //!< Number of symbols for the SHR SFD
     double phr;         //!< Number of symbols for the PHR
-} LrWpanPhyPpduHeaderSymbolNumber;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * This Phy option will be used to index various Tables in IEEE802.15.4-2011
  */
-typedef enum
+enum LrWpanPhyOption
 {
     IEEE_802_15_4_868MHZ_BPSK,
     IEEE_802_15_4_915MHZ_BPSK,
@@ -97,7 +97,7 @@
     IEEE_802_15_4_915MHZ_OQPSK,
     IEEE_802_15_4_2_4GHZ_OQPSK,
     IEEE_802_15_4_INVALID_PHY_OPTION
-} LrWpanPhyOption;
+};
 
 /**
  * \ingroup lr-wpan
@@ -105,7 +105,7 @@
  * IEEE802.15.4-2006 PHY Emumerations Table 18
  * in section 6.2.3
  */
-typedef enum
+enum LrWpanPhyEnumeration
 {
     IEEE_802_15_4_PHY_BUSY = 0x00,
     IEEE_802_15_4_PHY_BUSY_RX = 0x01,
@@ -120,7 +120,7 @@
     IEEE_802_15_4_PHY_UNSUPPORTED_ATTRIBUTE = 0xa,
     IEEE_802_15_4_PHY_READ_ONLY = 0xb,
     IEEE_802_15_4_PHY_UNSPECIFIED = 0xc // all cases not covered by ieee802.15.4
-} LrWpanPhyEnumeration;
+};
 
 namespace TracedValueCallback
 {
@@ -139,7 +139,7 @@
  *
  * IEEE802.15.4-2006 PHY PIB Attribute Identifiers Table 23 in section 6.4.2
  */
-typedef enum
+enum LrWpanPibAttributeIdentifier
 {
     phyCurrentChannel = 0x00,
     phyChannelsSupported = 0x01,
@@ -149,14 +149,14 @@
     phyMaxFrameDuration = 0x05,
     phySHRDuration = 0x06,
     phySymbolsPerOctet = 0x07
-} LrWpanPibAttributeIdentifier;
+};
 
 /**
  * \ingroup lr-wpan
  *
  * IEEE802.15.4-2006 PHY PIB Attributes Table 23 in section 6.4.2
  */
-typedef struct
+struct LrWpanPhyPibAttributes
 {
     uint8_t phyCurrentChannel;         //!< The RF channel to use
     uint32_t phyChannelsSupported[32]; //!< BitField representing the available channels supported
@@ -168,7 +168,7 @@
     uint32_t phyMaxFrameDuration; //!< The maximum number of symbols in a frame
     uint32_t phySHRDuration;      //!< The duration of the synchronization header (SHR) in symbols
     double phySymbolsPerOctet;    //!< The number of symbols per octet
-} LrWpanPhyPibAttributes;
+};
 
 /**
  * \ingroup lr-wpan
@@ -258,19 +258,6 @@
     static TypeId GetTypeId();
 
     /**
-     * The maximum packet size accepted by the PHY.
-     * See Table 22 in section 6.4.1 of IEEE 802.15.4-2006
-     */
-    static const uint32_t aMaxPhyPacketSize;
-
-    /**
-     * The turnaround time for switching the transceiver from RX to TX or vice
-     * versa.
-     * See Table 22 in section 6.4.1 of IEEE 802.15.4-2006
-     */
-    static const uint32_t aTurnaroundTime;
-
-    /**
      * Default constructor.
      */
     LrWpanPhy();
@@ -330,6 +317,26 @@
     void SetPhyOption(LrWpanPhyOption phyOption);
 
     /**
+     * Set the receiver power sensitivity used by this device in dBm.
+     *
+     * In ns-3 , rx sensitivity is only checked to be at least what is specified by
+     * the standard (-85dBm or -92dBm for BPSK bands). Most vendors provide better sensitivity
+     * options and exceed the minimum values proposed by the standard. Default sensitivity
+     * is -106.58 dBm (This does not include any noise figure).
+     * A sensitivity of -95dBm or less is considered by many vendors a high sensitivity.
+     *
+     * \param dbmSensitivity The receiver power sensitivity to set in dBm.
+     */
+    void SetRxSensitivity(double dbmSensitivity);
+
+    /**
+     * Get the receiver power sensitivity used by this device in dBm.
+     *
+     * \return The receiver power sensitivity used by this device in dBm.
+     */
+    double GetRxSensitivity();
+
+    /**
      * Notify the SpectrumPhy instance of an incoming waveform.
      *
      * @param params the SpectrumSignalParameters associated with the incoming waveform
@@ -542,21 +549,6 @@
                                         LrWpanPhyEnumeration oldState,
                                         LrWpanPhyEnumeration newState);
 
-  protected:
-    /**
-     * The data and symbol rates for the different PHY options.
-     * See Table 1 in section 6.1.1 IEEE 802.15.4-2006, IEEE 802.15.4c-2009, IEEE 802.15.4d-2009.
-     * Bit rate is in kbit/s.  Symbol rate is in ksymbol/s.
-     */
-    static const LrWpanPhyDataAndSymbolRates dataSymbolRates[IEEE_802_15_4_INVALID_PHY_OPTION];
-    /**
-     * The preamble, SFD, and PHR lengths in symbols for the different PHY options.
-     * See Table 19 and Table 20 in section 6.3 IEEE 802.15.4-2006, IEEE 802.15.4c-2009, IEEE
-     * 802.15.4d-2009.
-     */
-    static const LrWpanPhyPpduHeaderSymbolNumber
-        ppduHeaderSymbolNumbers[IEEE_802_15_4_INVALID_PHY_OPTION];
-
   private:
     /**
      * The second is true if the first is flagged as error/invalid.
@@ -751,10 +743,10 @@
     int8_t GetNominalTxPowerFromPib(uint8_t phyTransmitPower);
 
     /**
-     * Transform watts (W) to decibels milliwatts (DBm).
+     * Transform watts (W) to decibels milliwatts (dBm).
      *
-     * \param watt The Watts that will be converted to DBm.
-     * \return The value of Watts in DBm.
+     * \param watt The Watts that will be converted to dBm.
+     * \return The value of Watts in dBm.
      */
     double WToDbm(double watt);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-spectrum-value-helper.cc ns-3.38/src/lr-wpan/model/lr-wpan-spectrum-value-helper.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-spectrum-value-helper.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-spectrum-value-helper.cc	2023-03-16 20:54:23.632868500 -0700
@@ -126,6 +126,12 @@
     return noisePsd;
 }
 
+void
+LrWpanSpectrumValueHelper::SetNoiseFactor(double f)
+{
+    m_noiseFactor = f;
+}
+
 double
 LrWpanSpectrumValueHelper::TotalAvgPower(Ptr<const SpectrumValue> psd, uint32_t channel)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-spectrum-value-helper.h ns-3.38/src/lr-wpan/model/lr-wpan-spectrum-value-helper.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-spectrum-value-helper.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-spectrum-value-helper.h	2023-03-16 20:54:23.632868500 -0700
@@ -53,6 +53,12 @@
     Ptr<SpectrumValue> CreateNoisePowerSpectralDensity(uint32_t channel);
 
     /**
+     * Set the noise factor added to the thermal noise.
+     * \param f A dimensionless ratio (i.e. Not in dB)
+     */
+    void SetNoiseFactor(double f);
+
+    /**
      * \brief total average power of the signal is the integral of the PSD using
      * the limits of the given channel
      * \param psd spectral density
@@ -64,6 +70,8 @@
   private:
     /**
      * A scaling factor for the noise power.
+     * It specifies how much additional noise the device
+     * contribute to the thermal noise (floor noise).
      */
     double m_noiseFactor;
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/test/lr-wpan-ack-test.cc ns-3.38/src/lr-wpan/test/lr-wpan-ack-test.cc
--- ns-3.37/src/lr-wpan/test/lr-wpan-ack-test.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/test/lr-wpan-ack-test.cc	2023-03-16 20:54:23.632868500 -0700
@@ -57,13 +57,13 @@
     /**
      * Test modes
      */
-    typedef enum
+    enum TestMode_e
     {
         EXTENDED_ADDRESS_UNICAST, //!< extended addresses
         SHORT_ADDRESS_UNICAST,    //!< short addresses, unicast
         SHORT_ADDRESS_MULTICAST,  //!< short addresses, multicast
         SHORT_ADDRESS_BROADCAST,  //!< short addresses, broadcast
-    } TestMode_e;
+    };
 
     /**
      * Create test case
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/test/lr-wpan-mac-test.cc ns-3.38/src/lr-wpan/test/lr-wpan-mac-test.cc
--- ns-3.37/src/lr-wpan/test/lr-wpan-mac-test.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/test/lr-wpan-mac-test.cc	2023-03-16 20:54:23.632868500 -0700
@@ -308,11 +308,19 @@
      * \param params MLME scan confirm parameters
      */
     void ScanConfirm(MlmeScanConfirmParams params);
+    /**
+     * Function used to notify the reception of a beacon with payload.
+     *
+     * \param params The MLME-BEACON-NOTIFY.indication parameters
+     */
+    void BeaconNotifyIndication(MlmeBeaconNotifyIndicationParams params);
 
     void DoRun() override;
 
-    std::vector<PanDescriptor>
-        m_panDescriptorList; //!< The list of PAN descriptors accumulated during the scan
+    std::vector<PanDescriptor> m_panDescriptorList; //!< The list of PAN descriptors
+                                                    //!< accumulated during the scan.
+    uint32_t g_beaconPayloadSize;                   //!< The size of the beacon payload received
+                                                    //!< from a coordinator.
 };
 
 TestActiveScanPanDescriptors::TestActiveScanPanDescriptors()
@@ -334,12 +342,18 @@
 }
 
 void
+TestActiveScanPanDescriptors::BeaconNotifyIndication(MlmeBeaconNotifyIndicationParams params)
+{
+    g_beaconPayloadSize = params.m_sdu->GetSize();
+}
+
+void
 TestActiveScanPanDescriptors::DoRun()
 {
     /*
-     *      [00:01]                   [00:02]                                   [00:03]
-     *  PAN Coordinator 1 (PAN: 5)       End Device                        PAN Coordinator 2 (PAN:
-     * 7)
+     *      [00:01]                       [00:02]                             [00:03]
+     *  PAN Coordinator 1 (PAN: 5)       End Device                  PAN Coordinator 2 (PAN: 7)
+     *
      *       |--------100 m----------------|----------106 m -----------------------|
      *  Channel 12               (Active Scan channels 11-14)                 Channel 14
      *
@@ -352,7 +366,7 @@
      * the scanned channels). On reception of such commands, coordinators reply with a single beacon
      * which contains a PAN descriptor. The test makes sure that the PAN descriptors are received (2
      * PAN descriptors) and because both PAN coordinators are set to a different distance from the
-     * end device, their LQI values should be bellow 255 but above 0. Likewise, Coordinator 2 LQI
+     * end device, their LQI values should be below 255 but above 0. Likewise, Coordinator 2 LQI
      * value should be less than Coordinator 1 LQI value. The exact expected value of LQI is not
      * tested, this is dependable on the LQI implementation.
      */
@@ -408,6 +422,10 @@
     cb0 = MakeCallback(&TestActiveScanPanDescriptors::ScanConfirm, this);
     endNodeNetDevice->GetMac()->SetMlmeScanConfirmCallback(cb0);
 
+    MlmeBeaconNotifyIndicationCallback cb1;
+    cb1 = MakeCallback(&TestActiveScanPanDescriptors::BeaconNotifyIndication, this);
+    endNodeNetDevice->GetMac()->SetMlmeBeaconNotifyIndicationCallback(cb1);
+
     /////////////////
     // ACTIVE SCAN //
     /////////////////
@@ -427,7 +445,13 @@
                                    params);
 
     // PAN coordinator N2 (PAN 7) is set to channel 14 in non-beacon mode but answer to beacon
-    // requests.
+    // requests. The second coordinator includes a beacon payload of 25 bytes using the
+    // MLME-SET.request primitive.
+    Ptr<LrWpanMacPibAttributes> pibAttribute = Create<LrWpanMacPibAttributes>();
+    pibAttribute->macBeaconPayload = Create<Packet>(25);
+    coord2NetDevice->GetMac()->MlmeSetRequest(LrWpanMacPibAttributeIdentifier::macBeaconPayload,
+                                              pibAttribute);
+
     MlmeStartRequestParams params2;
     params2.m_panCoor = true;
     params2.m_PanId = 7;
@@ -482,6 +506,10 @@
         m_panDescriptorList[0].m_linkQuality,
         "Error, Coordinator 2 (PAN 7) LQI value should be less than Coordinator 1 (PAN 5).");
 
+    NS_TEST_EXPECT_MSG_EQ(g_beaconPayloadSize,
+                          25,
+                          "Error, Beacon Payload not received or incorrect size (25 bytes)");
+
     Simulator::Destroy();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/examples/lena-radio-link-failure.cc ns-3.38/src/lte/examples/lena-radio-link-failure.cc
--- ns-3.37/src/lte/examples/lena-radio-link-failure.cc	2022-11-01 17:37:24.543395300 -0700
+++ ns-3.38/src/lte/examples/lena-radio-link-failure.cc	2023-03-16 20:54:23.660868600 -0700
@@ -112,19 +112,21 @@
 }
 
 /// Map each of UE RRC states to its string representation.
-static const std::string g_ueRrcStateName[LteUeRrc::NUM_STATES] = {"IDLE_START",
-                                                                   "IDLE_CELL_SEARCH",
-                                                                   "IDLE_WAIT_MIB_SIB1",
-                                                                   "IDLE_WAIT_MIB",
-                                                                   "IDLE_WAIT_SIB1",
-                                                                   "IDLE_CAMPED_NORMALLY",
-                                                                   "IDLE_WAIT_SIB2",
-                                                                   "IDLE_RANDOM_ACCESS",
-                                                                   "IDLE_CONNECTING",
-                                                                   "CONNECTED_NORMALLY",
-                                                                   "CONNECTED_HANDOVER",
-                                                                   "CONNECTED_PHY_PROBLEM",
-                                                                   "CONNECTED_REESTABLISHING"};
+static const std::string g_ueRrcStateName[LteUeRrc::NUM_STATES] = {
+    "IDLE_START",
+    "IDLE_CELL_SEARCH",
+    "IDLE_WAIT_MIB_SIB1",
+    "IDLE_WAIT_MIB",
+    "IDLE_WAIT_SIB1",
+    "IDLE_CAMPED_NORMALLY",
+    "IDLE_WAIT_SIB2",
+    "IDLE_RANDOM_ACCESS",
+    "IDLE_CONNECTING",
+    "CONNECTED_NORMALLY",
+    "CONNECTED_HANDOVER",
+    "CONNECTED_PHY_PROBLEM",
+    "CONNECTED_REESTABLISHING",
+};
 
 /**
  * \param s The UE RRC state.
@@ -305,7 +307,7 @@
 }
 
 /**
- * Write the troughput to file.
+ * Write the throughput to file.
  *
  * \param firstWrite True if first time writing.
  * \param binSize Bin size.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/examples/lena-x2-handover.cc ns-3.38/src/lte/examples/lena-x2-handover.cc
--- ns-3.37/src/lte/examples/lena-x2-handover.cc	2022-11-01 17:37:24.543395300 -0700
+++ ns-3.38/src/lte/examples/lena-x2-handover.cc	2023-03-16 20:54:23.660868600 -0700
@@ -31,7 +31,7 @@
 NS_LOG_COMPONENT_DEFINE("LenaX2HandoverExample");
 
 /**
- * UE Connection established noticication.
+ * UE Connection established notification.
  *
  * \param context The context.
  * \param imsi The IMSI of the connected terminal.
@@ -82,7 +82,7 @@
 }
 
 /**
- * eNB Connection established noticication.
+ * eNB Connection established notification.
  *
  * \param context The context.
  * \param imsi The IMSI of the connected terminal.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/helper/cc-helper.cc ns-3.38/src/lte/helper/cc-helper.cc
--- ns-3.37/src/lte/helper/cc-helper.cc	2022-11-01 17:37:24.543395300 -0700
+++ ns-3.38/src/lte/helper/cc-helper.cc	2023-03-16 20:54:23.660868600 -0700
@@ -138,31 +138,31 @@
 }
 
 uint16_t
-CcHelper::GetNumberOfComponentCarriers()
+CcHelper::GetNumberOfComponentCarriers() const
 {
     return m_numberOfComponentCarriers;
 }
 
 uint32_t
-CcHelper::GetUlEarfcn()
+CcHelper::GetUlEarfcn() const
 {
     return m_ulEarfcn;
 }
 
 uint32_t
-CcHelper::GetDlEarfcn()
+CcHelper::GetDlEarfcn() const
 {
     return m_dlEarfcn;
 }
 
 uint16_t
-CcHelper::GetDlBandwidth()
+CcHelper::GetDlBandwidth() const
 {
     return m_dlBandwidth;
 }
 
 uint16_t
-CcHelper::GetUlBandwidth()
+CcHelper::GetUlBandwidth() const
 {
     return m_ulBandwidth;
 }
@@ -231,7 +231,7 @@
                          uint16_t dlBandwidth,
                          uint32_t ulEarfcn,
                          uint32_t dlEarfcn,
-                         bool isPrimary)
+                         bool isPrimary) const
 {
     ComponentCarrier cc;
     if (m_ulEarfcn != 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/helper/cc-helper.h ns-3.38/src/lte/helper/cc-helper.h
--- ns-3.37/src/lte/helper/cc-helper.h	2022-11-01 17:37:24.543395300 -0700
+++ ns-3.38/src/lte/helper/cc-helper.h	2023-03-16 20:54:23.660868600 -0700
@@ -74,7 +74,7 @@
      * \param dlBandwidth the DL bandwidth
      * \param ulEarfcn the UL EARFCN
      * \param dlEarfcn the DL EARFCN
-     * \param isPrimary ture if primary
+     * \param isPrimary true if primary
      * \returns the component carrier
      */
     ComponentCarrier DoCreateSingleCc(uint16_t ulBandwidth,
@@ -142,31 +142,31 @@
      *
      * \returns the number of component carriers
      */
-    uint16_t GetNumberOfComponentCarriers();
+    uint16_t GetNumberOfComponentCarriers() const;
     /**
      * Get UL EARFCN.
      *
      * \returns the UL EARFCN
      */
-    uint32_t GetUlEarfcn();
+    uint32_t GetUlEarfcn() const;
     /**
      * Get DL EARFCN.
      *
      * \returns the DL EARFCN
      */
-    uint32_t GetDlEarfcn();
+    uint32_t GetDlEarfcn() const;
     /**
      * Get DL bandwidth.
      *
      * \returns the DL bandwidth
      */
-    uint16_t GetDlBandwidth();
+    uint16_t GetDlBandwidth() const;
     /**
      * Get UL bandwidth.
      *
      * \returns the UL bandwidth
      */
-    uint16_t GetUlBandwidth();
+    uint16_t GetUlBandwidth() const;
 
   protected:
     // inherited from Object
@@ -188,7 +188,7 @@
                                     uint16_t dlBandwidth,
                                     uint32_t ulEarfcn,
                                     uint32_t dlEarfcn,
-                                    bool isPrimary);
+                                    bool isPrimary) const;
 
     /// Factory for each Carrier Component.
     ObjectFactory m_ccFactory;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/helper/lte-helper.cc ns-3.38/src/lte/helper/lte-helper.cc
--- ns-3.37/src/lte/helper/lte-helper.cc	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/helper/lte-helper.cc	2023-03-16 20:54:23.664868600 -0700
@@ -517,7 +517,7 @@
     Ptr<LteHandoverAlgorithm> handoverAlgorithm =
         m_handoverAlgorithmFactory.Create<LteHandoverAlgorithm>();
 
-    NS_ABORT_MSG_IF(m_componentCarrierPhyParams.size() != 0, "CC map is not clean");
+    NS_ABORT_MSG_IF(!m_componentCarrierPhyParams.empty(), "CC map is not clean");
     DoComponentCarrierConfigure(dev->GetUlEarfcn(),
                                 dev->GetDlEarfcn(),
                                 dev->GetUlBandwidth(),
@@ -837,7 +837,7 @@
     // of each component carrier. These values must be updated once the UE is attached to the
     // eNB and receives RRC Connection Reconfiguration message. In case of primary carrier or
     // a single carrier, these values will be updated once the UE will receive SIB2 and MIB.
-    NS_ABORT_MSG_IF(m_componentCarrierPhyParams.size() != 0, "CC map is not clean");
+    NS_ABORT_MSG_IF(!m_componentCarrierPhyParams.empty(), "CC map is not clean");
     DoComponentCarrierConfigure(dev->GetDlEarfcn() + 18000, dev->GetDlEarfcn(), 25, 25);
     NS_ABORT_MSG_IF(m_componentCarrierPhyParams.size() != m_noOfCcs,
                     "CC map size (" << m_componentCarrierPhyParams.size()
@@ -1426,7 +1426,7 @@
 {
     NS_LOG_FUNCTION(this << ulEarfcn << dlEarfcn << ulbw << dlbw);
 
-    NS_ABORT_MSG_IF(m_componentCarrierPhyParams.size() != 0, "CC map is not clean");
+    NS_ABORT_MSG_IF(!m_componentCarrierPhyParams.empty(), "CC map is not clean");
     Ptr<CcHelper> ccHelper = CreateObject<CcHelper>();
     ccHelper->SetNumberOfComponentCarriers(m_noOfCcs);
     ccHelper->SetUlEarfcn(ulEarfcn);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/component-carrier.cc ns-3.38/src/lte/model/component-carrier.cc
--- ns-3.37/src/lte/model/component-carrier.cc	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/component-carrier.cc	2023-03-16 20:54:23.664868600 -0700
@@ -253,7 +253,7 @@
 }
 
 uint16_t
-ComponentCarrierBaseStation::GetCellId()
+ComponentCarrierBaseStation::GetCellId() const
 {
     return m_cellId;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lte/model/component-carrier.h ns-3.38/src/lte/model/component-carrier.h
--- ns-3.37/src/lte/model/component-carrier.h	2022-11-01 17:37:24.547395200 -0700
+++ ns-3.38/src/lte/model/component-carrier.h	2023-03-16 20:54:23.664868600 -0700
@@ -188,7 +188,7 @@
      * Get cell identifier
      * \return cell identifier
      */
-    uint16_t GetCellId();
+    uint16_t GetCellId() const;
 
     /**
      * Set physical cell identifier
